﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Waf.BookLibrary.Library.Applications.Test;
using Waf.BookLibrary.Reporting.Applications.Controllers;
using Waf.BookLibrary.Library.Applications.Services;
using Waf.BookLibrary.Reporting.Applications.Views;
using System.Waf.Applications;
using Waf.BookLibrary.Reporting.Applications.ViewModels;
using Waf.BookLibrary.Reporting.Applications.Test.Reports;
using Waf.BookLibrary.Reporting.Applications.DataModels;

namespace Waf.BookLibrary.Reporting.Applications.Test.Controllers
{
    [TestClass]
    public class ModuleControllerTest : ReportingTestClass
    {
        [TestMethod]
        public void CreateReportTest()
        {
            var moduleController = Container.GetExportedValue<ModuleController>();
            moduleController.Initialize();
            moduleController.Run();

            var shellService = Container.GetExportedValue<IShellService>();
            Assert.IsTrue(shellService.IsReportingEnabled);

            var reportView = Container.GetExportedValue<IReportView>();
            Assert.AreEqual(reportView, shellService.LazyReportingView.Value);

            var reportViewModel = ViewHelper.GetViewModel<ReportViewModel>(reportView);
            reportViewModel.CreateBookListReportCommand.Execute(null);

            var bookListReport = (MockBookListReport)reportViewModel.Report;
            var bookListReportDataModel = (BookListReportDataModel)bookListReport.ReportData;

            Assert.IsNotNull(bookListReportDataModel.Books);
            Assert.AreEqual(0, bookListReportDataModel.BookCount);

            moduleController.Shutdown();
        }
    }
}
