﻿using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace EmailClient.Domain
{
    public class ExchangeSettings : ValidationModel, IEmailAccountSettings
    {
        private string serverPath;
        private string userName;


        [Required, Display(Name = "Exchange Server")]
        public string ServerPath
        {
            get { return serverPath; }
            set 
            {
                if (serverPath != value)
                {
                    serverPath = value;
                    RaisePropertyChanged("ServerPath");
                }
            }
        }

        [Required, Display(Name = "User Name")]
        public string UserName
        {
            get { return userName; }
            set 
            {
                if (userName != value)
                {
                    userName = value;
                    RaisePropertyChanged("UserName");
                }
            }
        }


        public override string ToString()
        {
            return "ExchangeSettings: " + ServerPath + " (" + UserName + ")";
        }
    }
}
